#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Coppia contenente k-gramma e conteggio delle sue occorrenze

struct Pair{
 char *kgram;  //   puntatore al prima k-gramma
 int occ;      //   numero occorrenze
};

int K; 	       //   lunghezza dei k-grammi


// funzione confronto lessicografico tra k-grammi

int comp_kgrams(char *a, char *b){

 int i;
 for (i=0; i< (K-1) && (a[i] == b[i]); i++);
 
 return (a[i]-b[i]);
}

int comp_kgrams_void(const void *_a, const void *_b){

 return comp_kgrams(*((char **)_a),*((char**)_b));

}

// confronto tra coppie

int comp_pair(const void *_a, const void *_b) {

  struct Pair *a = (struct Pair*)_a;
  struct Pair *b = (struct Pair*)_b;

  if (a->occ != b->occ) 
     return (b->occ - a->occ);
  else 
     return comp_kgrams(a->kgram, b->kgram);

}

int main(){

 char s[1000];
 char **kgrams;
 struct Pair* kfreq; 
 int T;
 int len, i, distinct;

 // lettura dei parametri in input
 scanf("%d",&K);
 scanf("%d",&T);
 scanf("%s",s);
 len = strlen(s);

 // costruzione della mappa k-grammi - occorrenze (tempo O(len* log len * K) )
 
 kgrams = malloc(sizeof(char *)*len);
 kfreq = malloc(len *sizeof(struct Pair)); 

 if (len < K) return;
 for (i=0; i<= (len-K); i++) 
  kgrams[i] = s+i;

 // ordina i k-grammi in modo da trovare k-grammi uguali consecutivamente
 qsort(kgrams, len-K+1, sizeof(char *), comp_kgrams_void); 

 distinct = 0;
 kfreq[0].kgram = kgrams[0]; 
 kfreq[0].occ = 1;

 // scandisce l'array ordinato kgram e conta il numero di volte che ciascun
 // k-gramma appare consecutivamente 
 for (i=1; i <= (len-K); i++) {
  if (comp_kgrams(kgrams[i], kgrams[i-1]) == 0) 
   kfreq[distinct].occ++;
  else{
   distinct++;
   kfreq[distinct].kgram = kgrams[i];
   kfreq[distinct].occ = 1;
  }
 }

 // stampa i primi T k-grammi con maggior valore di occ 
 qsort(kfreq, distinct, sizeof(struct Pair), comp_pair);
 for (i=0; i< T && i < distinct; i++){
   fwrite(kfreq[i].kgram, sizeof(char), K, stdout);
   printf(" %d\n", kfreq[i].occ);
 }


}
